package com.ruoyi.web.yh.reportProd.service.impl;

import com.ruoyi.web.yh.reportProd.domain.ReportProdVO;
import com.ruoyi.web.yh.reportProd.domain.bo.ReportProdBO;
import com.ruoyi.web.yh.reportProd.service.ReportProdConverter;
import com.ruoyi.web.yh.reportUserProd.domain.ReportUserProdVO;
import com.ruoyi.web.yh.reportUserProd.domain.bo.ReportUserProdBO;
import com.ruoyi.web.yh.reportUserProd.service.ReportUserProdConverter;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author wjh
 * 2024/11/2
 */
@Service
public class ReportProdConverterImpl implements ReportProdConverter {

    @Autowired
    private ReportUserProdConverter reportUserProdConverter;

    @Override
    public ReportProdBO toBoByCreate(ReportProdVO vo) {
        if (vo == null) {
            return null;
        }

        ReportProdBO bo = new ReportProdBO();
        bo.setPriceId(vo.getPriceId());
        bo.setNum(vo.getNum());
        bo.setPriceCategory(vo.getPriceCategory());
        bo.setPriceSize(vo.getPriceSize());
        bo.setPriceName(vo.getPriceName());
        bo.setPriceSubName(vo.getPriceSubName());
        bo.setPricePattern(vo.getPricePattern());
        bo.setPriceSpec(vo.getPriceSpec());
        bo.setPricePrice(vo.getPricePrice());
        bo.setPriceUnit(vo.getPriceUnit());
        bo.setPriceClassify(vo.getPriceClassify());
        bo.setPriceQuantity(vo.getPriceQuantity());
        bo.setPriceType(vo.getPriceType());
        bo.setRemark(vo.getRemark());

        // 用户产量明细
        List<ReportUserProdBO> userProdList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(vo.getUserProdList())) {
            for (ReportUserProdVO item : vo.getUserProdList()) {
                ReportUserProdBO userProd = reportUserProdConverter.toBoByCreate(item);
                userProdList.add(userProd);
            }
        }
        bo.setUserProdList(userProdList);

        return bo;
    }

    @Override
    public ReportProdBO toBoByUpdate(ReportProdVO vo) {
        if (vo == null) {
            return null;
        }

        ReportProdBO bo = new ReportProdBO();
        bo.setId(vo.getId());
        bo.setReportId(vo.getReportId());
        bo.setPriceId(vo.getPriceId());
        bo.setNum(vo.getNum());
        bo.setPriceCategory(vo.getPriceCategory());
        bo.setPriceSize(vo.getPriceSize());
        bo.setPriceName(vo.getPriceName());
        bo.setPriceSubName(vo.getPriceSubName());
        bo.setPricePattern(vo.getPricePattern());
        bo.setPriceSpec(vo.getPriceSpec());
        bo.setPricePrice(vo.getPricePrice());
        bo.setPriceUnit(vo.getPriceUnit());
        bo.setPriceClassify(vo.getPriceClassify());
        bo.setPriceQuantity(vo.getPriceQuantity());
        bo.setPriceType(vo.getPriceType());
        bo.setRemark(vo.getRemark());

        // 用户产量明细
        List<ReportUserProdBO> userProdList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(vo.getUserProdList())) {
            for (ReportUserProdVO item : vo.getUserProdList()) {
                ReportUserProdBO userProd = reportUserProdConverter.toBoByUpdate(item);
                userProdList.add(userProd);
            }
        }
        bo.setUserProdList(userProdList);

        return bo;
    }
}
