package com.ruoyi.web.yh.reportUserProd.mapper;

import java.util.List;
import com.ruoyi.web.yh.reportUserProd.domain.ReportUserProd;
import com.ruoyi.web.yh.reportUserProd.domain.ReportUserProdVO;
import com.ruoyi.web.yh.reportUserProd.domain.ReportUserProdQuery;
import com.ruoyi.web.yh.reportUserProd.domain.bo.ReportUserProdBO;
import org.apache.ibatis.annotations.Param;

/**
 * 员工产量Mapper接口
 *
 * @author ruoyi
 * @date 2024-11-02
 */
public interface ReportUserProdMapper
{
    /**
     * 查询员工产量
     *
     * @param id 员工产量主键
     * @return 员工产量
     */
    public ReportUserProdVO selectReportUserProdById(Long id);

    /**
     * 查询员工产量列表
     *
     * @param query 员工产量
     * @return 员工产量集合
     */
    public List<ReportUserProdVO> selectReportUserProdList(@Param("query")ReportUserProdQuery query);

    /**
     * 新增员工产量
     *
     * @param reportUserProd 员工产量
     * @return 结果
     */
    public int insertReportUserProd(ReportUserProd reportUserProd);

    /**
     * 修改员工产量
     *
     * @param reportUserProd 员工产量
     * @return 结果
     */
    public int updateReportUserProd(@Param("data") ReportUserProd reportUserProd);

    /**
     * 删除员工产量
     *
     * @param id 员工产量主键
     * @return 结果
     */
    public int deleteReportUserProdById(Long id);

    /**
     * 批量删除员工产量
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteReportUserProdByIds(Long[] ids);

    /**
     * 批量新增
     */
    int batchInsert(@Param("list") List<? extends ReportUserProd> list);

    /**
     * 批量更新
     */
    int batchUpdate(@Param("list") List<? extends ReportUserProd> list);

    /**
     * 批量逻辑删除
     */
    int batchLogicDel(@Param("ids") List<Long> ids);
}
